﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;

namespace XamDataGridClipboard
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Users = new ObservableCollection<UserViewModel>();
            Users.Add(new UserViewModel(new User()));

            DataContext = this;            
        }



        void xamDataGrid1_ExecutingCommand(object sender, Infragistics.Windows.Controls.Events.ExecutingCommandEventArgs e)
        {
            if (e.Command == DataPresenterCommands.Paste)
            {
                int recordsToPaste = RecorodsToPasteInClipboard();
                int fieldsToPaste = FieldsToPasteInClipboard();

                if ((sender as XamDataGrid).FieldLayouts[0].Fields.Count - (sender as XamDataGrid).ActiveCell.Field.Index > fieldsToPaste)
                {
                    int recordsAvailable = ((sender as XamDataGrid).Records.Count - 1) - (sender as XamDataGrid).ActiveRecord.Index;

                    if (recordsAvailable < recordsToPaste)
                    {
                        for (int i = 1; i < (recordsToPaste - recordsAvailable); i++)
                        {
                            ((sender as XamDataGrid).DataSource as ObservableCollection<UserViewModel>).Add(new UserViewModel());
                        }
                    }
                }
                else
                    e.Cancel = true;
            }
        }

        private int RecorodsToPasteInClipboard()
        {
            string clipboardData = Clipboard.GetData(DataFormats.Text) as string;
            int count = 0;

            foreach (char c in clipboardData.ToCharArray())
            {
                if (c == '\n')
                {
                    count++;
                }
            }
            return count;
        }

        private int FieldsToPasteInClipboard()
        {
            string clipboardData = Clipboard.GetData(DataFormats.Text) as string;
            int count = 0;

            foreach (char c in clipboardData.ToCharArray())
            {
                if (c == '\t')
                {
                    count++;
                }
                if (c == '\n')
                {
                    return count;
                }
            }
            return count;
        }

        public ObservableCollection<UserViewModel> Users { get; set; }     
    }
}
